jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
Andreas Gampe | 34a8a0f | 2016-07-20 21:09:29 -0700 | [diff] [blame] | 40 | tmp_dir="${TMPDIR}/${test_dir}" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | export JAVA="java" |
Orion Hodson | 64fe3be | 2018-06-15 12:50:22 +0100 | [diff] [blame] | 44 | export JAVAC="javac -g -Xlint:-options -source 1.8 -target 1.8" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 45 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 46 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 47 | export NEED_DEX="true" |
Alan Leung | cf2de16 | 2018-03-30 20:18:20 +0000 | [diff] [blame] | 48 | export USE_D8="true" |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 49 | export USE_DESUGAR="true" |
Ben Gruver | 14fc9db | 2017-04-28 15:30:49 -0700 | [diff] [blame] | 50 | export SMALI_ARGS="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 51 | |
Alan Leung | d5cbc56 | 2018-03-15 14:02:46 -0700 | [diff] [blame] | 52 | # If d8 was not set by the environment variable, assume it is in the path. |
| 53 | if [ -z "$D8" ]; then |
| 54 | export D8="d8" |
| 55 | fi |
| 56 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 57 | # If dx was not set by the environment variable, assume it is in the path. |
| 58 | if [ -z "$DX" ]; then |
Orion Hodson | 64fe3be | 2018-06-15 12:50:22 +0100 | [diff] [blame] | 59 | export DX="d8-compat-dx" |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 60 | fi |
| 61 | |
Orion Hodson | 64fe3be | 2018-06-15 12:50:22 +0100 | [diff] [blame] | 62 | export DEXMERGER="$D8" |
Alan Leung | d5cbc56 | 2018-03-15 14:02:46 -0700 | [diff] [blame] | 63 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 64 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 65 | if [ -z "$JASMIN" ]; then |
| 66 | export JASMIN="jasmin" |
| 67 | fi |
| 68 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 69 | # If smali was not set by the environment variable, assume it is in the path. |
| 70 | if [ -z "$SMALI" ]; then |
| 71 | export SMALI="smali" |
| 72 | fi |
| 73 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 74 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 75 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 76 | export ANDROID_BUILD_TOP=$oldwd |
| 77 | fi |
| 78 | |
Dan Willemsen | 12371e9 | 2017-03-06 17:55:20 -0800 | [diff] [blame] | 79 | # OUT_DIR defaults to out, and may be relative to $ANDROID_BUILD_TOP. |
| 80 | # Convert it to an absolute path, since we cd into the tmp_dir to run the tests. |
| 81 | export OUT_DIR=${OUT_DIR:-out} |
| 82 | if [[ "$OUT_DIR" != /* ]]; then |
| 83 | export OUT_DIR=$ANDROID_BUILD_TOP/$OUT_DIR |
| 84 | fi |
| 85 | |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 86 | # ANDROID_HOST_OUT is not set in a build environment. |
| 87 | if [ -z "$ANDROID_HOST_OUT" ]; then |
Dan Willemsen | 12371e9 | 2017-03-06 17:55:20 -0800 | [diff] [blame] | 88 | export ANDROID_HOST_OUT=${OUT_DIR}/host/linux-x86 |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 89 | fi |
| 90 | |
Alex Light | 680cbf2 | 2018-10-31 11:00:19 -0700 | [diff] [blame] | 91 | host_lib_root=${ANDROID_HOST_OUT} |
| 92 | |
Igor Murashkin | e518193 | 2017-06-15 16:03:50 -0700 | [diff] [blame] | 93 | # Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false. |
Igor Murashkin | d323277 | 2017-06-22 14:54:13 -0700 | [diff] [blame] | 94 | if [ -z "$DESUGAR" ]; then |
Igor Murashkin | e518193 | 2017-06-15 16:03:50 -0700 | [diff] [blame] | 95 | export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh" |
| 96 | fi |
| 97 | |
Igor Murashkin | 271a0f8 | 2017-02-14 21:14:17 +0000 | [diff] [blame] | 98 | # Zipalign is not on the PATH in some configs, auto-detect it. |
| 99 | if [ -z "$ZIPALIGN" ]; then |
| 100 | if which zipalign >/dev/null; then |
| 101 | ZIPALIGN="zipalign"; |
| 102 | else |
| 103 | # TODO: Add a dependency for zipalign in Android.run-test.mk |
| 104 | # once it doesn't depend on libandroidfw (b/35246701) |
| 105 | case "$OSTYPE" in |
| 106 | darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;; |
| 107 | linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;; |
| 108 | *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;; |
| 109 | esac |
| 110 | fi |
| 111 | fi |
| 112 | export ZIPALIGN |
| 113 | |
David Brazdil | 122c663 | 2018-01-24 17:32:49 +0000 | [diff] [blame] | 114 | # If hiddenapi was not set by the environment variable, assume it is in |
| 115 | # ANDROID_HOST_OUT. |
David Brazdil | 11b67b2 | 2018-01-18 16:41:40 +0000 | [diff] [blame] | 116 | if [ -z "$HIDDENAPI" ]; then |
David Brazdil | 122c663 | 2018-01-24 17:32:49 +0000 | [diff] [blame] | 117 | export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi" |
David Brazdil | 11b67b2 | 2018-01-18 16:41:40 +0000 | [diff] [blame] | 118 | fi |
| 119 | |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 120 | chroot= |
| 121 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 122 | info="info.txt" |
| 123 | build="build" |
| 124 | run="run" |
| 125 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 126 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 127 | output="output.txt" |
| 128 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 129 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 130 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 131 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 132 | testlib="arttestd" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 133 | run_args=(--quiet) |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 134 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 135 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 136 | quiet="no" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 137 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 138 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 139 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 140 | dev_mode="no" |
Alex Light | 8d94ddd | 2019-12-18 11:13:03 -0800 | [diff] [blame] | 141 | create_runner="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 142 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 143 | debug_mode="no" |
Xueliang Zhong | 48ca6a6 | 2019-03-07 14:48:55 +0000 | [diff] [blame^] | 144 | simulator_mode="no" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 145 | relocate="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 146 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 147 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 148 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 149 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 150 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 151 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 152 | basic_verify="false" |
| 153 | gc_verify="false" |
| 154 | gc_stress="false" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 155 | jvmti_trace_stress="false" |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 156 | jvmti_field_stress="false" |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 157 | jvmti_step_stress="false" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 158 | jvmti_redefine_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 159 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 160 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 161 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 162 | have_image="yes" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 163 | android_root="/system" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 164 | bisection_search="no" |
Martin Stjernholm | 4815e72 | 2019-09-24 16:20:09 +0100 | [diff] [blame] | 165 | timeout="" |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 166 | suspend_timeout="500000" |
Nicolas Geoffray | acc56ac | 2018-10-09 08:45:24 +0100 | [diff] [blame] | 167 | run_optimizing="false" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 168 | |
Alex Light | 20802ca | 2018-12-05 15:36:03 -0800 | [diff] [blame] | 169 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and |
| 170 | # ART output to approximately 128MB. This should be more than sufficient |
| 171 | # for any test while still catching cases of runaway output. |
| 172 | # Set a hard limit to encourage ART developers to increase the ulimit here if |
| 173 | # needed to support a test case rather than resetting the limit in the run |
| 174 | # script for the particular test in question. Adjust this if needed for |
| 175 | # particular configurations. |
| 176 | file_ulimit=128000 |
| 177 | |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 178 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 179 | while true; do |
| 180 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 181 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 182 | DEX_LOCATION=$tmp_dir |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 183 | run_args+=(--host) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 184 | shift |
Xueliang Zhong | 48ca6a6 | 2019-03-07 14:48:55 +0000 | [diff] [blame^] | 185 | elif [ "x$1" = "x--simulate-arm64" ]; then |
| 186 | simulator_mode="yes" |
| 187 | shift |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 188 | elif [ "x$1" = "x--quiet" ]; then |
| 189 | quiet="yes" |
| 190 | shift |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 191 | elif [ "x$1" = "x--use-java-home" ]; then |
| 192 | if [ -n "${JAVA_HOME}" ]; then |
| 193 | export JAVA="${JAVA_HOME}/bin/java" |
| 194 | export JAVAC="${JAVA_HOME}/bin/javac -g" |
| 195 | else |
| 196 | echo "Passed --use-java-home without JAVA_HOME variable set!" |
| 197 | usage="yes" |
| 198 | fi |
| 199 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 200 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 201 | target_mode="no" |
Alex Light | 2c7aaeb | 2017-01-27 14:08:17 -0800 | [diff] [blame] | 202 | DEX_LOCATION="$tmp_dir" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 203 | runtime="jvm" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 204 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 205 | NEED_DEX="false" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 206 | run_args+=(--jvm) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 207 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 208 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 209 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 210 | testlib="arttest" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 211 | run_args+=(-O) |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 212 | shift |
| 213 | elif [ "x$1" = "x--dalvik" ]; then |
| 214 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 215 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 216 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 217 | elif [ "x$1" = "x--no-image" ]; then |
| 218 | have_image="no" |
| 219 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 220 | elif [ "x$1" = "x--relocate" ]; then |
| 221 | relocate="yes" |
| 222 | shift |
| 223 | elif [ "x$1" = "x--no-relocate" ]; then |
| 224 | relocate="no" |
| 225 | shift |
| 226 | elif [ "x$1" = "x--prebuild" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 227 | run_args+=(--prebuild) |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 228 | prebuild_mode="yes" |
| 229 | shift; |
Mathieu Chartier | dcd56c9 | 2017-11-20 20:30:24 -0800 | [diff] [blame] | 230 | elif [ "x$1" = "x--compact-dex-level" ]; then |
| 231 | option="$1" |
| 232 | shift |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 233 | run_args+=("$option" "$1") |
Mathieu Chartier | dcd56c9 | 2017-11-20 20:30:24 -0800 | [diff] [blame] | 234 | shift; |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 235 | elif [ "x$1" = "x--strip-dex" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 236 | run_args+=(--strip-dex) |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 237 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 238 | elif [ "x$1" = "x--debuggable" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 239 | run_args+=(-Xcompiler-option --debuggable) |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 240 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 241 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 242 | elif [ "x$1" = "x--no-prebuild" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 243 | run_args+=(--no-prebuild) |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 244 | prebuild_mode="no" |
| 245 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 246 | elif [ "x$1" = "x--gcverify" ]; then |
| 247 | basic_verify="true" |
| 248 | gc_verify="true" |
| 249 | shift |
| 250 | elif [ "x$1" = "x--gcstress" ]; then |
| 251 | basic_verify="true" |
| 252 | gc_stress="true" |
| 253 | shift |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 254 | elif [ "x$1" = "x--jvmti-step-stress" ]; then |
| 255 | jvmti_step_stress="true" |
| 256 | shift |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 257 | elif [ "x$1" = "x--jvmti-redefine-stress" ]; then |
| 258 | jvmti_redefine_stress="true" |
| 259 | shift |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 260 | elif [ "x$1" = "x--jvmti-field-stress" ]; then |
| 261 | jvmti_field_stress="true" |
| 262 | shift |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 263 | elif [ "x$1" = "x--jvmti-trace-stress" ]; then |
| 264 | jvmti_trace_stress="true" |
Alex Light | 8f2c6d4 | 2017-04-10 16:27:35 -0700 | [diff] [blame] | 265 | shift |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 266 | elif [ "x$1" = "x--suspend-timeout" ]; then |
| 267 | shift |
| 268 | suspend_timeout="$1" |
| 269 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 270 | elif [ "x$1" = "x--image" ]; then |
| 271 | shift |
| 272 | image="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 273 | run_args+=(--image "$image") |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 274 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 275 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 276 | shift |
| 277 | option="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 278 | run_args+=(-Xcompiler-option "$option") |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 279 | shift |
Orion Hodson | e1fb77f | 2017-02-27 13:57:18 +0000 | [diff] [blame] | 280 | elif [ "x$1" = "x--build-option" ]; then |
| 281 | shift |
| 282 | option="$1" |
| 283 | build_args="${build_args} $option" |
| 284 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 285 | elif [ "x$1" = "x--runtime-option" ]; then |
| 286 | shift |
| 287 | option="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 288 | run_args+=(--runtime-option "$option") |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 289 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 290 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 291 | shift |
| 292 | gdb_arg="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 293 | run_args+=(--gdb-arg "$gdb_arg") |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 294 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 295 | elif [ "x$1" = "x--debug" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 296 | run_args+=(--debug) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 297 | shift |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 298 | elif [ "x$1" = "x--debug-wrap-agent" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 299 | run_args+=(--debug-wrap-agent) |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 300 | shift |
Alex Light | 0e151e7 | 2017-10-25 10:50:35 -0700 | [diff] [blame] | 301 | elif [ "x$1" = "x--with-agent" ]; then |
| 302 | shift |
| 303 | option="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 304 | run_args+=(--with-agent "$1") |
Alex Light | 0e151e7 | 2017-10-25 10:50:35 -0700 | [diff] [blame] | 305 | shift |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 306 | elif [ "x$1" = "x--debug-agent" ]; then |
| 307 | shift |
| 308 | option="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 309 | run_args+=(--debug-agent "$1") |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 310 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 311 | elif [ "x$1" = "x--gdb" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 312 | run_args+=(--gdb) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 313 | dev_mode="yes" |
| 314 | shift |
Alex Light | e4b4a18 | 2019-02-12 14:19:49 -0800 | [diff] [blame] | 315 | elif [ "x$1" = "x--gdbserver-bin" ]; then |
| 316 | shift |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 317 | run_args+=(--gdbserver-bin "$1") |
Alex Light | e4b4a18 | 2019-02-12 14:19:49 -0800 | [diff] [blame] | 318 | shift |
| 319 | elif [ "x$1" = "x--gdbserver-port" ]; then |
| 320 | shift |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 321 | run_args+=(--gdbserver-port "$1") |
Alex Light | e4b4a18 | 2019-02-12 14:19:49 -0800 | [diff] [blame] | 322 | shift |
| 323 | elif [ "x$1" = "x--gdbserver" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 324 | run_args+=(--gdbserver) |
Alex Light | e4b4a18 | 2019-02-12 14:19:49 -0800 | [diff] [blame] | 325 | dev_mode="yes" |
| 326 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 327 | elif [ "x$1" = "x--strace" ]; then |
| 328 | strace="yes" |
Martin Stjernholm | 4815e72 | 2019-09-24 16:20:09 +0100 | [diff] [blame] | 329 | run_args+=(--invoke-with strace --invoke-with -o --invoke-with "$tmp_dir/$strace_output") |
| 330 | timeout="${timeout:-1800}" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 331 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 332 | elif [ "x$1" = "x--zygote" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 333 | run_args+=(--zygote) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 334 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 335 | elif [ "x$1" = "x--interpreter" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 336 | run_args+=(--interpreter) |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 337 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 338 | elif [ "x$1" = "x--jit" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 339 | run_args+=(--jit) |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 340 | shift |
Nicolas Geoffray | acc56ac | 2018-10-09 08:45:24 +0100 | [diff] [blame] | 341 | elif [ "x$1" = "x--baseline" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 342 | run_args+=(--baseline) |
Nicolas Geoffray | acc56ac | 2018-10-09 08:45:24 +0100 | [diff] [blame] | 343 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 344 | elif [ "x$1" = "x--optimizing" ]; then |
Nicolas Geoffray | acc56ac | 2018-10-09 08:45:24 +0100 | [diff] [blame] | 345 | run_optimizing="true" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 346 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 347 | elif [ "x$1" = "x--no-verify" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 348 | run_args+=(--no-verify) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 349 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 350 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 351 | run_args+=(--verify-soft-fail) |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 352 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 353 | elif [ "x$1" = "x--no-optimize" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 354 | run_args+=(--no-optimize) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 355 | shift |
| 356 | elif [ "x$1" = "x--no-precise" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 357 | run_args+=(--no-precise) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 358 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 359 | elif [ "x$1" = "x--invoke-with" ]; then |
| 360 | shift |
| 361 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 362 | if [ "x$what" = "x" ]; then |
| 363 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 364 | usage="yes" |
| 365 | break |
| 366 | fi |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 367 | run_args+=(--invoke-with "${what}") |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 368 | shift |
Alex Light | 8d94ddd | 2019-12-18 11:13:03 -0800 | [diff] [blame] | 369 | elif [ "x$1" = "x--create-runner" ]; then |
| 370 | run_args+=(--create-runner --dry-run) |
| 371 | dev_mode="yes" |
| 372 | never_clean="yes" |
| 373 | create_runner="yes" |
| 374 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 375 | elif [ "x$1" = "x--dev" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 376 | run_args+=(--dev) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 377 | dev_mode="yes" |
| 378 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 379 | elif [ "x$1" = "x--build-only" ]; then |
| 380 | build_only="yes" |
| 381 | shift |
| 382 | elif [ "x$1" = "x--output-path" ]; then |
| 383 | shift |
| 384 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 385 | if [ "x$tmp_dir" = "x" ]; then |
| 386 | echo "$0 missing argument to --output-path" 1>&2 |
| 387 | usage="yes" |
| 388 | break |
| 389 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 390 | shift |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 391 | elif [ "x$1" = "x--chroot" ]; then |
| 392 | shift |
| 393 | if [ "x$1" = "x" ]; then |
| 394 | echo "$0 missing argument to --chroot" 1>&2 |
| 395 | usage="yes" |
| 396 | break |
| 397 | fi |
| 398 | chroot="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 399 | run_args+=(--chroot "$1") |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 400 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 401 | elif [ "x$1" = "x--android-root" ]; then |
| 402 | shift |
| 403 | if [ "x$1" = "x" ]; then |
| 404 | echo "$0 missing argument to --android-root" 1>&2 |
| 405 | usage="yes" |
| 406 | break |
| 407 | fi |
| 408 | android_root="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 409 | run_args+=(--android-root "$1") |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 410 | shift |
Martin Stjernholm | e58624f | 2019-09-20 15:53:40 +0100 | [diff] [blame] | 411 | elif [ "x$1" = "x--android-art-root" ]; then |
Roland Levillain | 2807614 | 2019-01-10 16:39:25 +0000 | [diff] [blame] | 412 | shift |
| 413 | if [ "x$1" = "x" ]; then |
Martin Stjernholm | e58624f | 2019-09-20 15:53:40 +0100 | [diff] [blame] | 414 | echo "$0 missing argument to --android-art-root" 1>&2 |
Roland Levillain | 2807614 | 2019-01-10 16:39:25 +0000 | [diff] [blame] | 415 | usage="yes" |
| 416 | break |
| 417 | fi |
Martin Stjernholm | e58624f | 2019-09-20 15:53:40 +0100 | [diff] [blame] | 418 | run_args+=(--android-art-root "$1") |
Roland Levillain | 2807614 | 2019-01-10 16:39:25 +0000 | [diff] [blame] | 419 | shift |
Roland Levillain | 90b3457 | 2019-06-14 15:23:15 +0100 | [diff] [blame] | 420 | elif [ "x$1" = "x--android-tzdata-root" ]; then |
| 421 | shift |
| 422 | if [ "x$1" = "x" ]; then |
| 423 | echo "$0 missing argument to --android-tzdata-root" 1>&2 |
| 424 | usage="yes" |
| 425 | break |
| 426 | fi |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 427 | run_args+=(--android-tzdata-root "$1") |
Roland Levillain | 90b3457 | 2019-06-14 15:23:15 +0100 | [diff] [blame] | 428 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 429 | elif [ "x$1" = "x--update" ]; then |
| 430 | update_mode="yes" |
| 431 | shift |
| 432 | elif [ "x$1" = "x--help" ]; then |
| 433 | usage="yes" |
| 434 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 435 | elif [ "x$1" = "x--64" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 436 | run_args+=(--64) |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 437 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 438 | shift |
Alex Light | 680cbf2 | 2018-10-31 11:00:19 -0700 | [diff] [blame] | 439 | elif [ "x$1" = "x--bionic" ]; then |
| 440 | # soong linux_bionic builds are 64bit only. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 441 | run_args+=(--bionic --host --64) |
Alex Light | 680cbf2 | 2018-10-31 11:00:19 -0700 | [diff] [blame] | 442 | suffix64="64" |
| 443 | target_mode="no" |
| 444 | DEX_LOCATION=$tmp_dir |
| 445 | host_lib_root=$OUT_DIR/soong/host/linux_bionic-x86 |
| 446 | shift |
Alex Light | 6f342dd | 2019-03-27 17:15:42 +0000 | [diff] [blame] | 447 | elif [ "x$1" = "x--runtime-extracted-zipapex" ]; then |
| 448 | shift |
| 449 | # TODO Should we allow the java.library.path to search the zipapex too? |
| 450 | # Not needed at the moment and adding it will be complicated so for now |
| 451 | # we'll ignore this. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 452 | run_args+=(--host --runtime-extracted-zipapex "$1") |
Alex Light | 6f342dd | 2019-03-27 17:15:42 +0000 | [diff] [blame] | 453 | target_mode="no" |
| 454 | DEX_LOCATION=$tmp_dir |
| 455 | shift |
Alex Light | 20802ca | 2018-12-05 15:36:03 -0800 | [diff] [blame] | 456 | elif [ "x$1" = "x--runtime-zipapex" ]; then |
| 457 | shift |
| 458 | # TODO Should we allow the java.library.path to search the zipapex too? |
| 459 | # Not needed at the moment and adding it will be complicated so for now |
| 460 | # we'll ignore this. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 461 | run_args+=(--host --runtime-zipapex "$1") |
Alex Light | 20802ca | 2018-12-05 15:36:03 -0800 | [diff] [blame] | 462 | target_mode="no" |
| 463 | DEX_LOCATION=$tmp_dir |
| 464 | # apex_payload.zip is quite large we need a high enough ulimit to |
| 465 | # extract it. 512mb should be good enough. |
| 466 | file_ulimit=512000 |
| 467 | shift |
Martin Stjernholm | 4815e72 | 2019-09-24 16:20:09 +0100 | [diff] [blame] | 468 | elif [ "x$1" = "x--timeout" ]; then |
| 469 | shift |
| 470 | if [ "x$1" = "x" ]; then |
| 471 | echo "$0 missing argument to --timeout" 1>&2 |
| 472 | usage="yes" |
| 473 | break |
| 474 | fi |
| 475 | timeout="$1" |
| 476 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 477 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 478 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 479 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 480 | elif [ "x$1" = "x--stream" ]; then |
| 481 | trace_stream="true" |
| 482 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 483 | elif [ "x$1" = "x--always-clean" ]; then |
| 484 | always_clean="yes" |
| 485 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 486 | elif [ "x$1" = "x--never-clean" ]; then |
| 487 | never_clean="yes" |
| 488 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 489 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 490 | run_args+=(--dex2oat-swap) |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 491 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 492 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 493 | shift |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 494 | run_args+=(--instruction-set-features "$1") |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 495 | shift |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 496 | elif [ "x$1" = "x--bisection-search" ]; then |
| 497 | bisection_search="yes" |
| 498 | shift |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 499 | elif [ "x$1" = "x--vdex" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 500 | run_args+=(--vdex) |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 501 | shift |
Nicolas Geoffray | baeaa9b | 2018-01-26 14:31:17 +0000 | [diff] [blame] | 502 | elif [ "x$1" = "x--dm" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 503 | run_args+=(--dm) |
Nicolas Geoffray | baeaa9b | 2018-01-26 14:31:17 +0000 | [diff] [blame] | 504 | shift |
Nicolas Geoffray | 7498105 | 2017-01-16 17:54:09 +0000 | [diff] [blame] | 505 | elif [ "x$1" = "x--vdex-filter" ]; then |
| 506 | shift |
| 507 | filter=$1 |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 508 | run_args+=(--vdex-filter "$filter") |
Nicolas Geoffray | 7498105 | 2017-01-16 17:54:09 +0000 | [diff] [blame] | 509 | shift |
Jeff Hao | 002b931 | 2017-03-27 16:23:08 -0700 | [diff] [blame] | 510 | elif [ "x$1" = "x--random-profile" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 511 | run_args+=(--random-profile) |
Jeff Hao | 002b931 | 2017-03-27 16:23:08 -0700 | [diff] [blame] | 512 | shift |
Shubham Ajmera | 981d99c | 2017-08-17 14:11:08 -0700 | [diff] [blame] | 513 | elif [ "x$1" = "x--dex2oat-jobs" ]; then |
| 514 | shift |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 515 | run_args+=(-Xcompiler-option "-j$1") |
Shubham Ajmera | 981d99c | 2017-08-17 14:11:08 -0700 | [diff] [blame] | 516 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 517 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 518 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 519 | usage="yes" |
| 520 | break |
| 521 | else |
| 522 | break |
| 523 | fi |
| 524 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 525 | |
Orion Hodson | 6aa4e0d | 2018-05-25 09:39:16 +0100 | [diff] [blame] | 526 | if [ "$usage" = "no" -a "x$1" = "x" ]; then |
| 527 | echo "missing test to run" 1>&2 |
| 528 | usage="yes" |
| 529 | fi |
| 530 | |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 531 | # The DEX_LOCATION with the chroot prefix, if any. |
| 532 | chroot_dex_location="$chroot$DEX_LOCATION" |
| 533 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 534 | # Allocate file descriptor real_stderr and redirect it to the shell's error |
| 535 | # output (fd 2). |
| 536 | if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then |
| 537 | exec {real_stderr}>&2 |
| 538 | else |
| 539 | # In bash before version 4.1 we need to do a manual search for free file |
| 540 | # descriptors. |
| 541 | FD=3 |
| 542 | while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done |
| 543 | real_stderr=$FD |
| 544 | eval "exec ${real_stderr}>&2" |
| 545 | fi |
| 546 | if [ "$quiet" = "yes" ]; then |
| 547 | # Force the default standard output and error to go to /dev/null so we will |
| 548 | # not print them. |
| 549 | exec 1>/dev/null |
| 550 | exec 2>/dev/null |
| 551 | fi |
| 552 | |
| 553 | function err_echo() { |
| 554 | echo "$@" 1>&${real_stderr} |
| 555 | } |
| 556 | |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 557 | # tmp_dir may be relative, resolve. |
| 558 | # |
| 559 | # Cannot use realpath, as it does not exist on Mac. |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 560 | # Cannot use a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 561 | # Cannot use readlink -m, as it does not exist on Mac. |
| 562 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 563 | noncanonical_tmp_dir=$tmp_dir |
Andreas Gampe | 86459c0 | 2019-08-29 14:01:18 -0700 | [diff] [blame] | 564 | tmp_dir="`cd $oldwd ; python -c "import os; import sys; sys.stdout.write(os.path.realpath('$tmp_dir'))"`" |
| 565 | if [ -z $tmp_dir ] ; then |
| 566 | err_echo "Failed to resolve $tmp_dir" |
| 567 | exit 1 |
| 568 | fi |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 569 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 570 | |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 571 | # Add thread suspend timeout flag |
Narayan Kamath | f86c393 | 2017-01-24 17:40:47 +0000 | [diff] [blame] | 572 | if [ ! "$runtime" = "jvm" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 573 | run_args+=(--runtime-option "-XX:ThreadSuspendTimeout=$suspend_timeout") |
Narayan Kamath | f86c393 | 2017-01-24 17:40:47 +0000 | [diff] [blame] | 574 | fi |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 575 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 576 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 577 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 578 | run_args+=(--runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0) |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 579 | fi |
| 580 | if [ "$gc_verify" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 581 | run_args+=(--runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc) |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 582 | fi |
| 583 | if [ "$gc_stress" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 584 | run_args+=(--gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m) |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 585 | fi |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 586 | if [ "$jvmti_redefine_stress" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 587 | run_args+=(--no-app-image --jvmti-redefine-stress) |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 588 | fi |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 589 | if [ "$jvmti_step_stress" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 590 | run_args+=(--no-app-image --jvmti-step-stress) |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 591 | fi |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 592 | if [ "$jvmti_field_stress" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 593 | run_args+=(--no-app-image --jvmti-field-stress) |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 594 | fi |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 595 | if [ "$jvmti_trace_stress" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 596 | run_args+=(--no-app-image --jvmti-trace-stress) |
Alex Light | 8f2c6d4 | 2017-04-10 16:27:35 -0700 | [diff] [blame] | 597 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 598 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 599 | run_args+=(--runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000) |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 600 | if [ "$trace_stream" = "true" ]; then |
| 601 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 602 | # the ability to analyze the file and just write to /dev/null. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 603 | run_args+=(--runtime-option -Xmethod-trace-file:/dev/null) |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 604 | # Enable streaming mode. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 605 | run_args+=(--runtime-option -Xmethod-trace-stream) |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 606 | else |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 607 | run_args+=(--runtime-option "-Xmethod-trace-file:${DEX_LOCATION}/trace.bin") |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 608 | fi |
| 609 | elif [ "$trace_stream" = "true" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 610 | err_echo "Cannot use --stream without --trace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 611 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 612 | fi |
Martin Stjernholm | 4815e72 | 2019-09-24 16:20:09 +0100 | [diff] [blame] | 613 | if [ -n "$timeout" ]; then |
| 614 | run_args+=(--timeout "$timeout") |
| 615 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 616 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 617 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 93d6846 | 2018-01-02 11:59:45 +0000 | [diff] [blame] | 618 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 619 | function guess_target_arch_name() { |
Andreas Gampe | d0566d4 | 2018-06-06 09:54:34 -0700 | [diff] [blame] | 620 | # Check whether this is a device with native bridge. Currently this is hardcoded |
| 621 | # to x86 + arm. |
David Srbecky | 928d28e | 2020-04-01 17:50:51 +0100 | [diff] [blame] | 622 | local guess_path=${ANDROID_PRODUCT_OUT}/system/apex/com.android.art.testing/javalib |
| 623 | local x86_arm=`ls ${guess_path} | sort | grep -E '^(arm|x86)$'` |
Andreas Gampe | d0566d4 | 2018-06-06 09:54:34 -0700 | [diff] [blame] | 624 | # Collapse line-breaks into spaces |
| 625 | x86_arm=$(echo $x86_arm) |
| 626 | if [ "x$x86_arm" = "xarm x86" ] ; then |
| 627 | err_echo "Native-bridge configuration detected." |
| 628 | # We only support the main arch for tests. |
| 629 | if [ "x${suffix64}" = "x64" ]; then |
| 630 | target_arch_name="" |
| 631 | else |
| 632 | target_arch_name=x86 |
| 633 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 634 | else |
David Srbecky | 928d28e | 2020-04-01 17:50:51 +0100 | [diff] [blame] | 635 | local grep32bit=`ls ${guess_path} | grep -E '^(arm|x86)$'` |
| 636 | local grep64bit=`ls ${guess_path} | grep -E '^(arm64|x86_64)$'` |
Andreas Gampe | d0566d4 | 2018-06-06 09:54:34 -0700 | [diff] [blame] | 637 | if [ "x${suffix64}" = "x64" ]; then |
| 638 | target_arch_name=${grep64bit} |
| 639 | else |
| 640 | target_arch_name=${grep32bit} |
| 641 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 642 | fi |
| 643 | } |
| 644 | |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 645 | function guess_host_arch_name() { |
| 646 | if [ "x${suffix64}" = "x64" ]; then |
| 647 | host_arch_name="x86_64" |
| 648 | else |
| 649 | host_arch_name="x86" |
| 650 | fi |
| 651 | } |
| 652 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 653 | if [ "$target_mode" = "no" ]; then |
| 654 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 655 | if [ "$prebuild_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 656 | err_echo "--prebuild with --jvm is unsupported" |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 657 | exit 1 |
| 658 | fi |
| 659 | else |
| 660 | # ART/Dalvik host mode. |
| 661 | if [ -n "$chroot" ]; then |
| 662 | err_echo "--chroot with --host is unsupported" |
| 663 | exit 1 |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 664 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 665 | fi |
| 666 | fi |
| 667 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 668 | if [ ! "$runtime" = "jvm" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 669 | run_args+=(--lib "$lib") |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 670 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 671 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 672 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 673 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 93d6846 | 2018-01-02 11:59:45 +0000 | [diff] [blame] | 674 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Victor Chang | 759845f | 2019-08-06 16:04:36 +0100 | [diff] [blame] | 675 | bpath="${framework}/core-icu4j.jar:${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 676 | run_args+=(--boot --runtime-option "-Xbootclasspath:${bpath}") |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 677 | else |
| 678 | true # defaults to using target BOOTCLASSPATH |
| 679 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 680 | elif [ "$runtime" = "art" ]; then |
Xueliang Zhong | 48ca6a6 | 2019-03-07 14:48:55 +0000 | [diff] [blame^] | 681 | if [ "$target_mode" = "no" ] && [ "$simulator_mode" = "no" ]; then |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 682 | guess_host_arch_name |
David Srbecky | 928d28e | 2020-04-01 17:50:51 +0100 | [diff] [blame] | 683 | run_args+=(--boot "${ANDROID_HOST_OUT}/apex/com.android.art/javalib/boot.art") |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 684 | run_args+=(--runtime-option "-Djava.library.path=${host_lib_root}/lib${suffix64}:${host_lib_root}/nativetest${suffix64}") |
Xueliang Zhong | 48ca6a6 | 2019-03-07 14:48:55 +0000 | [diff] [blame^] | 685 | elif [ "$simulator_mode" = "yes" ]; then |
| 686 | run_args+=(--simulate-isa "arm64") |
| 687 | run_args+=(--boot "${ANDROID_PRODUCT_OUT}/system/apex/com.android.art.testing/javalib/boot.art") |
| 688 | run_args+=(--runtime-option "-Djava.library.path=${host_lib_root}/lib${suffix64}:${host_lib_root}/nativetest${suffix64}") |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 689 | else |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 690 | guess_target_arch_name |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 691 | run_args+=(--runtime-option "-Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}") |
David Srbecky | 928d28e | 2020-04-01 17:50:51 +0100 | [diff] [blame] | 692 | run_args+=(--boot "/apex/com.android.art/javalib/boot.art") |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 693 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 694 | if [ "$relocate" = "yes" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 695 | run_args+=(--relocate) |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 696 | else |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 697 | run_args+=(--no-relocate) |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 698 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 699 | elif [ "$runtime" = "jvm" ]; then |
| 700 | # TODO: Detect whether the host is 32-bit or 64-bit. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 701 | run_args+=(--runtime-option "-Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64") |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 702 | fi |
| 703 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 704 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 705 | if [ "$runtime" != "art" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 706 | err_echo "--no-image is only supported on the art runtime" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 707 | exit 1 |
| 708 | fi |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 709 | run_args+=(--no-image) |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 710 | fi |
| 711 | |
Alex Light | 8d94ddd | 2019-12-18 11:13:03 -0800 | [diff] [blame] | 712 | if [ "$create_runner" = "yes" -a "$target_mode" = "yes" ]; then |
| 713 | err_echo "--create-runner does not function for non --host tests" |
| 714 | usage="yes" |
| 715 | fi |
| 716 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 717 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 718 | err_echo "--dev and --update are mutually exclusive" |
| 719 | usage="yes" |
| 720 | fi |
| 721 | |
| 722 | if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then |
| 723 | err_echo "--dev and --quiet are mutually exclusive" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 724 | usage="yes" |
| 725 | fi |
| 726 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 727 | if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then |
| 728 | err_echo "--bisection-search and --prebuild are mutually exclusive" |
| 729 | usage="yes" |
| 730 | fi |
| 731 | |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 732 | # TODO: Chroot-based bisection search is not supported yet (see below); implement it. |
| 733 | if [ "$bisection_search" = "yes" -a -n "$chroot" ]; then |
| 734 | err_echo "--chroot with --bisection-search is unsupported" |
| 735 | exit 1 |
| 736 | fi |
| 737 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 738 | if [ "$usage" = "no" ]; then |
| 739 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 740 | test_dir=`basename "$oldwd"` |
| 741 | else |
| 742 | test_dir="$1" |
| 743 | fi |
| 744 | |
| 745 | if [ '!' -d "$test_dir" ]; then |
| 746 | td2=`echo ${test_dir}-*` |
| 747 | if [ '!' -d "$td2" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 748 | err_echo "${test_dir}: no such test directory" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 749 | usage="yes" |
| 750 | fi |
| 751 | test_dir="$td2" |
| 752 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 753 | # Shift to get rid of the test name argument. The rest of the arguments |
| 754 | # will get passed to the test run. |
| 755 | shift |
| 756 | fi |
| 757 | |
| 758 | if [ "$usage" = "yes" ]; then |
| 759 | prog=`basename $prog` |
| 760 | ( |
| 761 | echo "usage:" |
| 762 | echo " $prog --help Print this message." |
| 763 | echo " $prog [options] [test-name] Run test normally." |
| 764 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 765 | "(dumps to stdout)." |
Alex Light | 8d94ddd | 2019-12-18 11:13:03 -0800 | [diff] [blame] | 766 | echo " $prog --create-runner [options] [test-name]" |
| 767 | echo " Creates a runner script for use with other " \ |
| 768 | "tools (e.g. parallel_run.py)." |
| 769 | echo " The script will only run the test portion, and " \ |
| 770 | "share oat and dex files." |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 771 | echo " $prog --update [options] [test-name] Update mode" \ |
| 772 | "(replaces expected.txt)." |
| 773 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 774 | "current directory." |
| 775 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 776 | echo " -O Run non-debug rather than debug build (off by default)." |
| 777 | echo " -Xcompiler-option Pass an option to the compiler." |
Orion Hodson | e1fb77f | 2017-02-27 13:57:18 +0000 | [diff] [blame] | 778 | echo " --build-option Pass an option to the build script." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 779 | echo " --runtime-option Pass an option to the runtime." |
Mathieu Chartier | dcd56c9 | 2017-11-20 20:30:24 -0800 | [diff] [blame] | 780 | echo " --compact-dex-level Specify a compact dex level to the compiler." |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 781 | echo " --debug Wait for the default debugger to attach." |
| 782 | echo " --debug-agent <agent-path>" |
| 783 | echo " Wait for the given debugger agent to attach. Currently" |
| 784 | echo " only supported on host." |
| 785 | echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props" |
| 786 | echo " to load the debugger agent specified by --debug-agent." |
Alex Light | 0e151e7 | 2017-10-25 10:50:35 -0700 | [diff] [blame] | 787 | echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 788 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 789 | echo " --gdb Run under gdb; incompatible with some tests." |
Alex Light | e4b4a18 | 2019-02-12 14:19:49 -0800 | [diff] [blame] | 790 | echo " --gdbserver Start gdbserver (defaults to port :5039)." |
| 791 | echo " --gdbserver-port <port>" |
| 792 | echo " Start gdbserver with the given COMM (see man gdbserver)." |
| 793 | echo " --gdbserver-bin <binary>" |
| 794 | echo " Use the given binary as gdbserver." |
| 795 | echo " --gdb-arg Pass an option to gdb or gdbserver." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 796 | echo " --build-only Build test files only (off by default)." |
| 797 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 798 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 799 | echo " --optimizing Enable optimizing compiler (default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 800 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 801 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 802 | echo " Verification is enabled if neither --no-verify" |
| 803 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 804 | echo " --no-optimize Turn off optimization (on by default)." |
| 805 | echo " --no-precise Turn off precise GC (on by default)." |
| 806 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 807 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 808 | echo " other runtime options are ignored." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 809 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 810 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 811 | echo " the test." |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 812 | echo " --strip-dex Strip the dex files before starting test." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 813 | echo " --relocate Force the use of relocating in the test, making" |
| 814 | echo " the image and oat files be relocated to a random" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 815 | echo " address before running." |
| 816 | echo " --no-relocate Force the use of no relocating in the test. (default)" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 817 | echo " --image Run the test using a precompiled boot image. (default)" |
| 818 | echo " --no-image Run the test without a precompiled boot image." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 819 | echo " --host Use the host-mode virtual machine." |
| 820 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 821 | echo " --dalvik Use Dalvik (off by default)." |
| 822 | echo " --jvm Use a host-local RI virtual machine." |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 823 | echo " --use-java-home Use the JAVA_HOME environment variable" |
| 824 | echo " to find the java compiler and runtime" |
| 825 | echo " (if applicable) to run the test with." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 826 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 827 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 828 | echo " --64 Run the test in 64-bit mode" |
Alex Light | 680cbf2 | 2018-10-31 11:00:19 -0700 | [diff] [blame] | 829 | echo " --bionic Use the (host, 64-bit only) linux_bionic libc runtime" |
Alex Light | 20802ca | 2018-12-05 15:36:03 -0800 | [diff] [blame] | 830 | echo " --runtime-zipapex [file]" |
| 831 | echo " Use the given zipapex file to provide runtime binaries" |
Alex Light | 6f342dd | 2019-03-27 17:15:42 +0000 | [diff] [blame] | 832 | echo " --runtime-extracted-zipapex [dir]" |
| 833 | echo " Use the given extracted zipapex directory to provide" |
| 834 | echo " runtime binaries" |
Martin Stjernholm | 4815e72 | 2019-09-24 16:20:09 +0100 | [diff] [blame] | 835 | echo " --timeout n Test timeout in seconds" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 836 | echo " --trace Run with method tracing" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 837 | echo " --strace Run with syscall tracing from strace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 838 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 839 | echo " --gcstress Run with gc stress testing" |
| 840 | echo " --gcverify Run with gc verification" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 841 | echo " --jvmti-trace-stress Run with jvmti method tracing stress testing" |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 842 | echo " --jvmti-step-stress Run with jvmti single step stress testing" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 843 | echo " --jvmti-redefine-stress" |
| 844 | echo " Run with jvmti method redefinition stress testing" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 845 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 846 | echo " --never-clean Keep the test files even if the test succeeds." |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 847 | echo " --chroot [newroot] Run with root directory set to newroot." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 848 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Victor Chang | 6461124 | 2019-07-05 16:32:41 +0100 | [diff] [blame] | 849 | echo " --android-i18n-root [path]" |
| 850 | echo " The path on target for the i18n module root." |
| 851 | echo " (/apex/com.android.i18n by default)." |
Martin Stjernholm | e58624f | 2019-09-20 15:53:40 +0100 | [diff] [blame] | 852 | echo " --android-art-root [path]" |
| 853 | echo " The path on target for the ART module root." |
Martin Stjernholm | d6be5da | 2019-07-16 17:14:46 +0100 | [diff] [blame] | 854 | echo " (/apex/com.android.art by default)." |
Roland Levillain | 90b3457 | 2019-06-14 15:23:15 +0100 | [diff] [blame] | 855 | echo " --android-tzdata-root [path]" |
| 856 | echo " The path on target for the Android Time Zone Data root." |
| 857 | echo " (/apex/com.android.tzdata by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 858 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 859 | echo " --instruction-set-features [string]" |
| 860 | echo " Set instruction-set-features for compilation." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 861 | echo " --quiet Don't print anything except failure messages" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 862 | echo " --bisection-search Perform bisection bug search." |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 863 | echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild." |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 864 | echo " --suspend-timeout Change thread suspend timeout ms (default 500000)." |
Shubham Ajmera | 981d99c | 2017-08-17 14:11:08 -0700 | [diff] [blame] | 865 | echo " --dex2oat-jobs Number of dex2oat jobs." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 866 | ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set. |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 867 | exit 1 |
| 868 | fi |
| 869 | |
| 870 | cd "$test_dir" |
| 871 | test_dir=`pwd` |
| 872 | |
| 873 | td_info="${test_dir}/${info}" |
| 874 | td_expected="${test_dir}/${expected}" |
| 875 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 876 | if [ ! -r $td_info ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 877 | err_echo "${test_dir}: missing file $td_info" |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 878 | exit 1 |
| 879 | fi |
| 880 | |
| 881 | if [ ! -r $td_expected ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 882 | err_echo "${test_dir}: missing file $td_expected" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 883 | exit 1 |
| 884 | fi |
| 885 | |
| 886 | # copy the test to a temp dir and run it |
| 887 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 888 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 889 | |
| 890 | rm -rf "$tmp_dir" |
Alex Light | 0aa7a5a | 2018-10-10 15:58:14 +0000 | [diff] [blame] | 891 | cp -LRp "$test_dir" "$tmp_dir" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 892 | cd "$tmp_dir" |
| 893 | |
| 894 | if [ '!' -r "$build" ]; then |
| 895 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 896 | else |
| 897 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 898 | fi |
| 899 | |
| 900 | if [ '!' -r "$run" ]; then |
| 901 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 902 | else |
| 903 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 904 | fi |
| 905 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 906 | if [ '!' -r "$check_cmd" ]; then |
| 907 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 908 | else |
| 909 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 910 | fi |
| 911 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 912 | chmod 755 "$build" |
| 913 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 914 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 915 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 916 | export TEST_NAME=`basename ${test_dir}` |
| 917 | |
Nicolas Geoffray | 1949baf | 2017-10-17 12:14:53 +0000 | [diff] [blame] | 918 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 919 | # Checker when compiled with Optimizing on host. |
| 920 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
Nicolas Geoffray | 8c41a0b | 2020-02-06 16:52:11 +0000 | [diff] [blame] | 921 | if [ "$runtime" = "art" -a "$run_optimizing" = "true" ]; then |
Nicolas Geoffray | 1949baf | 2017-10-17 12:14:53 +0000 | [diff] [blame] | 922 | # In no-prebuild or no-image mode, the compiler only quickens so disable the checker. |
| 923 | if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then |
| 924 | run_checker="yes" |
| 925 | |
Xueliang Zhong | 48ca6a6 | 2019-03-07 14:48:55 +0000 | [diff] [blame^] | 926 | if [ "$simulator_mode" = "yes" ]; then |
| 927 | cfg_output_dir="$tmp_dir" |
| 928 | checker_args="--arch=ARM64" |
| 929 | elif [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 1949baf | 2017-10-17 12:14:53 +0000 | [diff] [blame] | 930 | cfg_output_dir="$tmp_dir" |
| 931 | checker_args="--arch=${host_arch_name^^}" |
| 932 | else |
| 933 | cfg_output_dir="$DEX_LOCATION" |
| 934 | checker_args="--arch=${target_arch_name^^}" |
| 935 | fi |
| 936 | |
| 937 | if [ "$debuggable" = "yes" ]; then |
| 938 | checker_args="$checker_args --debuggable" |
| 939 | fi |
| 940 | |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 941 | run_args+=(-Xcompiler-option "--dump-cfg=$cfg_output_dir/$cfg_output" -Xcompiler-option -j1) |
Nicolas Geoffray | 1949baf | 2017-10-17 12:14:53 +0000 | [diff] [blame] | 942 | fi |
| 943 | fi |
| 944 | fi |
| 945 | |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 946 | run_args+=(--testlib "${testlib}") |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 947 | |
Alex Light | 20802ca | 2018-12-05 15:36:03 -0800 | [diff] [blame] | 948 | if ! ulimit -f ${file_ulimit}; then |
Richard Uhler | 020c0f3 | 2017-03-14 16:23:17 +0000 | [diff] [blame] | 949 | err_echo "ulimit file size setting failed" |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 950 | fi |
| 951 | |
Igor Murashkin | 2de6e08 | 2018-02-28 15:25:23 -0800 | [diff] [blame] | 952 | # Tell the build script which mode (target, host, jvm) we are building for |
| 953 | # to determine the bootclasspath at build time. |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 954 | if [[ "$target_mode" == "yes" ]]; then |
| 955 | build_args="$build_args --target" |
| 956 | else |
Igor Murashkin | 2de6e08 | 2018-02-28 15:25:23 -0800 | [diff] [blame] | 957 | if [[ $runtime == "jvm" ]]; then |
| 958 | build_args="$build_args --jvm" |
| 959 | else |
| 960 | build_args="$build_args --host" |
| 961 | fi |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 962 | fi |
| 963 | |
| 964 | if [[ "$dev_mode" == "yes" ]]; then |
| 965 | build_args="$build_args --dev" |
| 966 | fi |
| 967 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 968 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 969 | good_build="yes" |
| 970 | good_run="yes" |
Alex Light | 77fee87 | 2017-09-05 14:51:49 -0700 | [diff] [blame] | 971 | export TEST_RUNTIME="${runtime}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 972 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 973 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 974 | build_exit="$?" |
| 975 | echo "build exit status: $build_exit" 1>&2 |
| 976 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 977 | echo "${test_dir}: running..." 1>&2 |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 978 | "./${run}" "${run_args[@]}" "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 979 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 980 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 981 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 982 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 983 | if [ "$target_mode" = "yes" ]; then |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 984 | adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 985 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 986 | "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 987 | checker_exit="$?" |
| 988 | if [ "$checker_exit" = "0" ]; then |
| 989 | good="yes" |
| 990 | fi |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 991 | err_echo "checker exit status: $checker_exit" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 992 | else |
| 993 | good="yes" |
| 994 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 995 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 996 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 997 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 998 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 999 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1000 | build_exit="$?" |
| 1001 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 1002 | echo "${test_dir}: running..." 1>&2 |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 1003 | "./${run}" "${run_args[@]}" "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 1004 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 1005 | if [ "$target_mode" = "yes" ]; then |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1006 | adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 1007 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 1008 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 1009 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1010 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 1011 | good="yes" |
| 1012 | else |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1013 | cat "$build_output" 1>&${real_stderr} 1>&2 |
| 1014 | err_echo "build exit status: $build_exit" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1015 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 1016 | elif [ "$build_only" = "yes" ]; then |
| 1017 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 1018 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 1019 | build_exit="$?" |
| 1020 | if [ "$build_exit" '!=' '0' ]; then |
| 1021 | cp "$build_output" "$output" |
| 1022 | echo "build exit status: $build_exit" >>"$output" |
| 1023 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 1024 | if [ "$?" '!=' "0" ]; then |
| 1025 | good="no" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1026 | err_echo "BUILD FAILED For ${TEST_NAME}" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 1027 | fi |
| 1028 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 1029 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 1030 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 1031 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1032 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 1033 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1034 | build_exit="$?" |
| 1035 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 1036 | echo "${test_dir}: running..." 1>&2 |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 1037 | "./${run}" "${run_args[@]}" "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 1038 | run_exit="$?" |
| 1039 | if [ "$run_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1040 | err_echo "run exit status: $run_exit" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 1041 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 1042 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 1043 | if [ "$target_mode" = "yes" ]; then |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1044 | adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 1045 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 1046 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 1047 | checker_exit="$?" |
| 1048 | if [ "$checker_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1049 | err_echo "checker exit status: $checker_exit" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 1050 | good_run="no" |
| 1051 | else |
| 1052 | good_run="yes" |
| 1053 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 1054 | else |
| 1055 | good_run="yes" |
| 1056 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1057 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 1058 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1059 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 1060 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 1061 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 1062 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 1063 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 1064 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 1065 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 1066 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 1067 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1068 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 1069 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1070 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 1071 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 1072 | # output == expected |
| 1073 | good="yes" |
| 1074 | echo "${test_dir}: succeeded!" 1>&2 |
| 1075 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1076 | fi |
| 1077 | fi |
| 1078 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1079 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1080 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1081 | echo "${test_dir}: FAILED!" |
| 1082 | echo ' ' |
| 1083 | echo '#################### info' |
| 1084 | cat "${td_info}" | sed 's/^/# /g' |
| 1085 | echo '#################### diffs' |
Nicolas Geoffray | 30a11eb | 2020-01-28 16:04:01 +0000 | [diff] [blame] | 1086 | if [ "$run_checker" == "yes" ]; then |
| 1087 | # Checker failures dump the whole CFG, so we output the whole diff. |
| 1088 | diff --strip-trailing-cr -u "$expected" "$output" |
| 1089 | else |
Hans Boehm | 80dc7dc | 2020-03-10 15:56:42 -0700 | [diff] [blame] | 1090 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 10000 |
Nicolas Geoffray | 30a11eb | 2020-01-28 16:04:01 +0000 | [diff] [blame] | 1091 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1092 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 1093 | if [ "$strace" = "yes" ]; then |
| 1094 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 1095 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 1096 | echo '####################' |
| 1097 | fi |
Andreas Gampe | e79ca19 | 2017-07-31 10:30:16 -0700 | [diff] [blame] | 1098 | if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then |
| 1099 | # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The |
| 1100 | # tools used by the given ABI work for both x86 and x86-64. |
| 1101 | echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000 |
| 1102 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1103 | echo ' ' |
| 1104 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1105 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1106 | ) 2>&${real_stderr} 1>&2 |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1107 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1108 | # Attempt bisection only if the test failed. |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1109 | # TODO: Implement support for chroot-based bisection search. |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1110 | if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then |
| 1111 | # Bisecting works by skipping different optimization passes which breaks checker assertions. |
| 1112 | if [ "$run_checker" == "yes" ]; then |
| 1113 | echo "${test_dir}: not bisecting, checker test." 1>&2 |
| 1114 | else |
| 1115 | # Increase file size limit, bisection search can generate large logfiles. |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1116 | echo "${test_dir}: bisecting..." 1>&2 |
| 1117 | cwd=`pwd` |
| 1118 | maybe_device_mode="" |
| 1119 | raw_cmd="" |
| 1120 | if [ "$target_mode" = "yes" ]; then |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1121 | # Produce cmdline.sh in $chroot_dex_location. "$@" is passed as a runtime option |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1122 | # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set |
| 1123 | # to exec in order to preserve pid when calling dalvikvm. This is required |
| 1124 | # for bisection search to correctly retrieve logs from device. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 1125 | "./${run}" "${run_args[@]}" --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1126 | adb shell chmod u+x "$chroot_dex_location/cmdline.sh" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1127 | maybe_device_mode="--device" |
| 1128 | raw_cmd="$DEX_LOCATION/cmdline.sh" |
| 1129 | else |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 1130 | raw_cmd="$cwd/${run} --external-log-tags "${run_args[@]}" $@" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1131 | fi |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1132 | # TODO: Pass a `--chroot` option to the bisection_search.py script and use it there. |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1133 | $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \ |
| 1134 | $maybe_device_mode \ |
| 1135 | --raw-cmd="$raw_cmd" \ |
| 1136 | --check-script="$cwd/check" \ |
| 1137 | --expected-output="$cwd/expected.txt" \ |
Wojciech Staszkiewicz | 0c88383 | 2016-09-26 17:51:52 -0700 | [diff] [blame] | 1138 | --logfile="$cwd/bisection_log.txt" \ |
Martin Stjernholm | 4815e72 | 2019-09-24 16:20:09 +0100 | [diff] [blame] | 1139 | --timeout=${timeout:-300} |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1140 | fi |
| 1141 | fi |
| 1142 | |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1143 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 1144 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1145 | cd "$oldwd" |
| 1146 | rm -rf "$tmp_dir" |
| 1147 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1148 | adb shell rm -rf $chroot_dex_location |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1149 | fi |
| 1150 | if [ "$good" = "yes" ]; then |
| 1151 | exit 0 |
| 1152 | fi |
| 1153 | fi |
| 1154 | |
| 1155 | |
| 1156 | ( |
| 1157 | if [ "$always_clean" = "yes" ]; then |
| 1158 | echo "${TEST_NAME} files deleted from host " |
| 1159 | if [ "$target_mode" == "yes" ]; then |
| 1160 | echo "and from target" |
| 1161 | fi |
| 1162 | else |
| 1163 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 1164 | if [ "$target_mode" == "yes" ]; then |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1165 | echo "and in ${chroot_dex_location} on target" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1166 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 1167 | fi |
| 1168 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1169 | ) 2>&${real_stderr} 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1170 | |
Alex Light | 6a870fa | 2016-05-31 16:36:19 -0700 | [diff] [blame] | 1171 | if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then |
| 1172 | exit 0 |
| 1173 | else |
| 1174 | exit 1 |
| 1175 | fi |